SystemOrganization addCategory: #'PDS-Singleton'!

Object subclass: #SingletonHierachy
	instanceVariableNames: 'data'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'PDS-Singleton'!

!SingletonHierachy commentStamp: 'MatteoST 12/3/2014 21:49' prior: 0!
A SingletonHierachy is a class that develop the Singleton pattern over a hierachy.

Instance Variables
	data:		<Object>

data
	- xxxxx
!

SingletonHierachy subclass: #SingleSon
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS-Singleton'!

!SingleSon commentStamp: 'sonmi 12/3/2014 11:55' prior: 0!
A SingleSon is aSingleton.

Instance Variables
	value:		generic basic value to store

value
	- number or letter


Test code for this class: 

| single tangle iniziale|
iniziale := Singleton current.
single := SingleSon current.
single value:740.
tangle := Singleton current.
tangle == single.
"the two instances referes to the same object, even if the frst instantiastion is a Singleton, and not a SingleSon isntance"!

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value
	"Returns the value instance"

	^value.! !

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value:anInteger
	"Store an integer in the variable value"

	value := anInteger.
	^self.! !

SingleSon subclass: #SingleSonSon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS-Singleton'!

!SingleSonSon commentStamp: 'MatteoST 12/3/2014 21:51' prior: 0!
A SingleSonSon is a deeper class of the SingletonHierachy.
!

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/8/2014 11:52'!
current
	"Return the unique instance of the singleton pattern"
	
	"The singleton instance is bound to the toplevel class: in this way there's no doubt which calss the singleton belongs. If 'self' is used then it is not possinle to control if the instance is referred to the topcass or one of its sons. So the client do not know if the son interface is available, so it is more secure to use only the top class interface, but at this point it's bettere to get explicit use of the top class in the instatiantion of the Singleton for an Hierachy"
	uniqueInstance isNil ifTrue: [ uniqueInstance := SingletonHierachy basicNew  ]. 
	^uniqueInstance.! !

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/3/2014 22:00'!
destroy
	"Destroys the singleton unique instances"

	uniqueInstance := nil.
	^self.! !

!SingletonHierachy class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/3/2014 22:01'!
new
	"Forbids the use un new message"

	self error: 'Please do not use the ''new'' message, this is a singleton'.! !

!SingletonHierachy methodsFor: 'accessing' stamp: 'MatteoST 12/3/2014 22:02'!
data
	^ data! !

!SingletonHierachy methodsFor: 'accessing' stamp: 'MatteoST 12/3/2014 22:02'!
data: anInteger
	data := anInteger! !
